/* Turtle graphic driver    ^[gG`R}h
      program name: tgd.c     (version 2.0)

      @OS-9/X680x0 ^[gEOtBbNEhCo[ƁAG`R}
      hłBł JICCoŋǊuOS-9/68000 g[jO}jAv
      CjďCAaApcKAFJ@pg.187 łBOS-9 ɂ́A
      ̎̃R}hȂ̂ŁA̖{{ƂāAHIɊgĂ
      ܂B
      @ OS-9S}[ŃAX68030 ̃p[\iEEBhE\
      ł邱ƂAM̘aS}[NĂ܂Bꂪ
      CɓŁAȂ畗ƂȖɕĂ܂BR}h
      sł̂ŁA}`^XN@\ȂǂāAvȂ
      Ă邱Ƃ܂B

      version  date        author     memo
      -------------------------------------------------------------------
       1.0     '88.01.27   Taq        OS-9/68000ڰݸƭ٣
       2.0     '95.05.06   a@   b̃g[jO˂

      Copyright (c) 1999,    Izumi Geotechnical Office inc.
          All rights reserved.     Kiso, Nagano prep, 399-6101, JAPAN
*/

#include <stdio.h>            /* printf() */
#include <math.h>             /* sin() */
#include <string.h>           /* strcmp() */
#include <X68K/pwindow.h>     /* personal window */

#define SIZE      100         /* X^bNETCY */
#define MOJI      512         /* ̃TCY */
#define HELP      "-?"        /* ₢킹 */
#define STDERR    2           /* WG[o̓pX */
#define X_AXIS    319         /* n_wʒu */
#define Y_AXIS    199         /* n_xʒu */
#define UP        0           /* y̏ */
#define DOWN      -1          /* @@V@@ */
#define OFF       0           /* tbO */
#define ON        -1          /* @@V@ */
#define UE        270         /* Jnixj */
#define MIGI      0           /* @@V@ */
#define MASK      0x80000000  /* }XNER[h */
#define TURTLE    "turtle graphic"
#define NSNTX     24          /* -? ̕\s */

char
      wrkbf[MOJI],
      buff[MOJI],
      for_text[MOJI],
      *errcomment[1] = {      /* G[̓e */
            "Ɍ܂肪܂B"
      },
      *comment[NSNTX] = {     /* syntax ̓e */
            "m\n",
            "\t 1.  tgd  [<߼>]",
            "m@\n",
            "\t OS-9/68000ڰݸƭ٣JICCoŋ pg.187 ɋLڂĂ",
            "\t ^[gEOtBbNEhCo[ƁAG`R}",
            "\t hłBHzĉL̑啝ȋ@\ǉƁAbƓ",
            "\t  /*  */ ̒߂At@C쐬ɗpł悤",
            "\t ̂łB OS-9 ̃R}h͂A񏈗()",
            "\t ̋@\̂܂܎g܂B",
            "\t yR}hꗗz@@[]łA()̓p[^",
            "\t\t cls    : ʂ̏        box    : lp``(x,y)",
            "\t\t origin : _ɖ߂        circle : ~`(a)",
            "\t\t up     : `悵Ȃ@      paint  : hԂ(x,y)",
            "\t\t down   :  V @        fill   : lp  V  (x,y)",
            "\t\t [f]orward: Oi(ޯ)  pattern: `p^[(ԍ)",
            "\t\t [r]ight: EɌ(x)      text   : `(\"\")",
            "\t\t [l]eft :  V (x)      dot    : Phbg`(1 or 0)",
            "\t\t [m]ove : ړ(x,y)     wait   : ҋ@(b/10)",
            "\t\t flush  : |o(0:ON)    do     : s(\"R}h\")",
            "\t\t q      : I",
            "mIvVn",
            "\t -? : gp@\B",
            "\t -t : ^CgEo[\B",
            "\t -f : |oiflushj}B",
            "\t -l : 荞݃R}h̕ʂo͂B"
      };

short
      pattern[16];      /* hԂp^[ */
double
      degree = 2.0 * PI / 360.0;    /* WAx */

int
      ttlopt,           /* ^CgEo[EIvV */
      listopt,          /* ̃R}ho */
      flushflg,         /* |o */
      path,             /* pXԍ */
      winId,            /* EBhEEpXԍ */
      phi,              /* y̌ */
      x_pos,            /* @V@Wʒu */
      y_pos,            /* @V@Wʒu */
      pen,              /* `y̏ */
      stack[SIZE];      /* ߃X^bN */

void analyze(int, char **);
int round(double);
void to_small(register char *);
int check_word(register char *);
void setmoji(register char *);
void g_origin(void);
void g_cls(void);
void g_forward(int **);
void g_right(int **);
void g_left(int **);
void g_af(int **);
void g_up(void);
void g_down(void);
void g_flush(int **);
void g_rect(int **);
void g_circle(int **);
void g_paint(void);
void g_fill(int **);
void g_ptn(int **);
void g_text(void);
void g_dot(int **);
void g_wait(int **);
void g_shell(void);
void wflush(void);
void subst(char *, int **);
void mainjob(void);
char *subjob(register char *);
int errorline(int);
void syntax(void);

int main(int argc, char *argv[])
{
      if (argc == 2 && strcmp(argv[1], HELP) == 0)
            syntax();
      else {
            analyze(argc, argv);    /* ̉ */
            mainjob();              /* CEvO */
      }
      return 0;
}

void analyze(int argc, char *argv[])
{
      char *p;
      while (--argc) {
            p = argv[argc];
            if (*p == '-') {        /* IvVwL */
                  while (*(++p)) {
                        switch (*p) {
                        case 't':
                              ttlopt = ON;
                              break;
                        case 'f':
                              flushflg = ON;
                              break;
                        case 'l':
                              listopt = ON;
                              break;
                        default:
                              errorline(1);
                              break;
                        }
                  }
            } else                  /* ̑̈ */
                  errorline(1);
      }
}

int round(double v)
{
      int j;
      if (fmod(fabs(v), 1.0) >= 0.5)
            j = (v > 0.0) ? ceil(v) : floor(v);
      else
            j = (v > 0.0) ? floor(v) : ceil(v);
      return j;
}

void to_small(register char *s)     /* ֕ϊ */
{
      if (*s != '"') {
            while (*s) {
                  if ('A' <= *s && *s <= 'Z')
                        *s += ' ';              /* 0x20 */
                  s++;
            }
      }
}

int check_word(register char *s)    /*  or H */
{
      int flag = OFF;
      while (*s) {
            if (*s != '-' && (*s < '0' || '9' < *s) {
                  flag = ON;
                  break;
            }
            s++;
      }
      return flag;
}

void setmoji(register char *p)      /* wrkbf  for_text  */
{
      register char *t;
      p++;                          /* [ " Ȃ */
      t = p + strlen(p) - 1;
      if (*t != '"')
            fprintf(stderr, "\"%s\"  command ?!\n", --p);
      else {
            *t = '\0';              /* E[ " Ȃ */
            t = for_text;
            while (*p) {            /* for_text ɓ] */
                  if (*p == '\\' && *(p + 1) == '`') {
                        *t = ' ';   /* \`  ' ' ɕϊ */
                        p += 2;
                  } else
                        *t = *p++;
                  t++;
            }
            *t = '\0';              /* ؂I */
      }
}

void g_origin(void)     /* command: _ɖ߂ */
{
      phi = UE;               /* ͏ */
      x_pos = X_AXIS;
      y_pos = Y_AXIS;         /* CWɃZbg */
      _wg_locate(path, winId, x_pos, y_pos);
      wflush();               /* |o */
}

void g_cls(void)        /* command: NAEXN[ */
{
      fprintf(stderr, "\x1b[1;1H");       /* \x1b --> ESC code */
      fprintf(stderr, "\x1b[j");
      fflush(stderr);
}

void g_forward(int **spp)     /* command: Oi */
{
      int r;
      double deg;
      r = *((*spp)--);
      deg = (double)phi * degree;
      x_pos += round((double)r * cos(deg));
      y_pos += round((double)r * sin(deg));
      if (pen == UP)
            _wg_locate(path, winId, x_pos, y_pos);
      else
            _wg_line(path, winId, x_pos, y_pos);
      wflush();
}

void g_right(int **spp)       /* command: E֌ */
{
      phi += *((*spp)--);
      phi %= 360;
}

void g_left(int **spp)        /* command: ֌ */
{
      phi -= *((*spp)--);
      phi %= 360;
}

void g_af(int **spp)          /* command: ړ */
{
      y_pos -= *((*spp)--);
      x_pos += *((*spp)--);
      if (pen == UP)
            _wg_locate(path, winId, x_pos, y_pos);
      else
            _wg_line(path, winId, x_pos, y_pos);
      wflush();
}

void g_up(void)         /* command: yグ */
{
      pen = UP;
}

void g_down(void)       /* command: y낷 */
{
      pen = DOWN;
}

void g_flush(int **spp)       /* command: |o[hݒ */
{
      int mode;
      mode = *((*spp)--);     /* OFF(0):`   ON(-1):ۗ */
      flushflg = (mode == OFF ? ON : OFF);
      if (mode == OFF)
            wflush();
}

void g_rect(int **spp)        /* lp`` */
{
      int tx,ty;
      tx = x_pos;
      ty = y_pos;
      y_pos -= *((*spp)--);
      x_pos += *((*spp)--);
      _wg_rect(path, winId, x_pos, y_pos);
      wflush();
      x_pos = tx;
      y_pos = ty;
}

void g_circle(int **spp)      /* ~` */
{
      int radius;
      radius = *((*spp)--);
      _wg_circle(path, winId, radius);
      wflush();
}

void g_paint(void)            /* hׂ */
{
      _wg_paint(path, winId);
      wflush();
}

void g_fill(int **spp)        /* p^[œhׂ */
{
      int tx,ty;
      tx = x_pos;
      ty = y_pos;
      y_pos -= *((*spp)--);
      x_pos += *((*spp)--);
      _wg_fill(path, winId, x_pos, y_pos);
      wflush();
      x_pos = tx;       /* sO̍Wɖ߂ */
      y_pos = ty;
}

void g_ptn(int **spp)         /* `͗l */
{
      int i;
      register int code,temp;
      i = *((*spp)--);
      switch (abs(i % 10)) {
      case 0:
            code = 0xffffffff;      /* 1111111111111111 */
            break;
      case 1:
            code = 0x55555555;      /* 0101010101010101 */
            break;
      case 2:
            code = 0x11111111;      /* 0001000100010001 */
            break;
      case 3:
            code = 0x00010001;      /* 0000000100000001 */
            break;
      case 4:
            code = 0x33333333;      /* 0011001100110011 */
            break;
      case 5:
            code = 0xc0c0c0c0;      /* 1100000011000000 */
            break;
      case 6:
            code = 0xeeeeeeee;      /* 1110111011101110 */
            break;
      case 7:
            code = 0xf0f0f0f0;      /* 1111000011110000 */
            break;
      case 8:
            code = 0xc4c4c4c4;      /* 1100010011000100 */
            break;
      default:
            code = 0xe080e080;      /* 1110000001000000 */
            break;
      }
      if (i < 0) {                  /* Ȅꍇ */
            for (i = 0; i < 16; i++) {
                  pattern[i] = code;
                  code >>= 1;
            }
      } else if (i >= 10) {         /* ̏ꍇ */
            for (i = 0; i < 16; i++) {
                  pattern[i] = code;
                  temp = code & MASK;
                  code <<= 1;
                  if (temp != 0)
                        code |= 1;
            }
      } else {                      /* cȂ̏ꍇ */
            for (i = 0; i < 16; i++)
                  pattern[i] = code;
      }
      _wg_ptn(path, winId, pattern);
}

void g_text(void)             /* ` */
{
      _wg_text(path, winId, for_text);
      wflush();
}

void g_dot(int **spp)         /* PsNZ` */
{
      int color;
      color = *((*spp)--);
      _wg_color(path, winId, color);
      _wg_dot(path, winId);
      wflush();
}

void g_wait(int **spp)        /* `̃^C~OƂ */
{
      int t;
      t = *((*spp)--);
      if (t > 0) {
            t *= 20;          /* { 25.6 ł */
            tsleep(t);
      } else
            fprintf(stderr, "i ?!\n");
}

void g_shell(void)            /* R}hs */
{
      int status;
      status = system(for_text);
      if (status != 0)
            exit(status);
}

struct set {
      char *oper;             /* ̊֐ւ̃|C^[Ee[u */
      void (*fn)();           /* ֐Q̖ɔzu邱ƁII@@ */
} _table[] = {
      "origin"    , g_origin,       /* _ɖ߂ */
      "cls"       , g_cls,          /* NAXN[ */
      "forward"   , g_forward,      /* Oi */
      "f"         , g_forward,      /* @V@@ */
      "move"      , g_af,           /* ړ */
      "m"         , g_af,           /* @V@@ */
      "right"     , g_right,        /* E֌ */
      "r"         , g_right,        /* @V@@ */
      "left"      , g_left,         /* ֌ */
      "l"         , g_left,         /* @V@@ */
      "up"        , g_up,           /* yグ */
      "down"      , g_down,         /* @V@낷 */
      "flush"     , g_flush,        /* |o[h */
      "box"       , g_rect,         /* lp`` */
      "circle"    , g_circle,       /* ~` */
      "paint"     , g_paint,        /* hׂ */
      "fill"      , g_fill,         /* p^[œhׂ */
      "pattern"   , g_ptn,          /* p^[ݒ肷 */
      "text"      , g_text,         /* ` */
      "dot"       , g_dot,          /* PsNZ` */
      "wait"      , g_wait,         /* `̃^C~OƂ */
      "do"        , g_shell,        /* R}hs */
      "#"         , g_orign         /* end of commands */
};

void wflush(void)       /* `悷 */
{
      if (flushflg == OFF)
            _pw_flush(path, winId, 8, 8, 642, 392, 0);
}

void subst(char *bf, int **spp)     /* L */
{
      *(++(*spp)) = atoi(bf);
}

void mainjob(void)      /* TuECvO */
{
      int *pointer,*stack_size,
            n,opn,comm_flag;
      char *p,*tp;
      /*  */
      path = STDERR;                      /* EBhEEpXԍ */
      winId = _pw_getsrvid(path);         /* EBhE ID ԍ */
      if (ttlopt != OFF)
            _pw_name(path, winId, TURTLE);
      for (n = 0; n < 16; n++)            /* fillp̏ */
            pattern[n] = 0x5555;
      _wg_ptn(path, winId, pattern);
      pointer = stack;                    /* X^bN̏ */
      stack_size = stack + SIZE - 1;
      comm_flag = OFF;                    /* RgstbO */

      /*  */
      gets(buff);
      while (! feof(stdin)) {
            p = buff;
            /* quit ͖߂݂ȂPsɖL̂ƁI */
            while (*p == ' ' || *p == '\t')
                  p++;
            if ((*p == 'q' || *p == 'Q') && *(p + 1) == '\0'
                                                && comm_flag == OFF)
                  break;
            while (*p) {
                  p = subjob(p);          /* ͕̕ */
                  if (listopt == OFF) {
                        if (strstr(wrkbf, "/*") != NULL     /* ? */
                                    || strstr(wrkbf, "*/") != NULL)
                              comm_flag = (*wrkbf == '/') ? ON : OFF;
                        else if (comm_flag == OFF) {  /* ޏ */
                              to_small(wrkbf);        /* ɕϊ */
                              n = 0;                  /* L[[h */
                              opn = -1;
                              while (*_table[n].oper != '#') {
                                    if (strcmp(wrkbf, _table[n].oper)
                                                                  == 0) {
                                          opn = n;
                                          break;
                                    }
                                    n += 1;
                              }
                              if (opn < 0) {    /* L[[h */
                                    if (check_word(wrkbf) == 0)   /*  */
                                          subst(wrkbf, &pointer);
                                    else if (*wrkbf == '"') /*  */
                                          setmoji(wrkbf);
                                    else                    /* Ӗs */
                                          fprintf(stderr,
                                                " what ?!: \"%s\"\n", wrkbf);
                              } else            /* L[[hL */
                                    /* oÅ֐s */
                                    (*(_table[opn].fn))(&pointer);
                        }
                  } else      /* ʂo͂ */
                        printf("%s\n", wrkbf);
            }
            gets(buff);
      }
      if (ttlopt != 0)
            _pw_name(path, winId, "shell");
}

char *subjob(register char *p)      /* ̓f[^̕ */
{
      register char *tp;
      tp = wrkbf;
      while (*p == ' ' || *p == '\t')     /* Xy[XA^uȂ */
            p++;
      if (*p == '"') {        /* ̕ */
            *tp++ = *p++;
            while (!(*p == '"' && *(p - 1) != '\\')) {
                  if (*p == '"' && *(p - 1) == '\\')
                        --tp;       /* echo "..." pɒǉ */
                  else if (*p == '\0')
                        break;
                  *tp++ = *p++;     /* wrkbf ɓ] */
            }
            if (*p != '\0')
                  *tp++ = *p++;     /* '"' ] */
      } else {                /* ʏR}h̉ */
            while (*p != ' ' && *p != '\t' && *p != '\0')
                  *tp++ = *p++;
      }
      *tp = '\0';             /* 𖾋L */
      return p;
}

int errorline(int i)
{
      fprintf(stderr, "   tgd: %s\n", errcomment[i - 1]);
      exit(i + 10);                 /* dz */
}

void syntax(void)
{
      int i;
      for (i = 0; i < NSNTX; i++)
            fprintf(stderr, "\t%s\n", comment[i]);
}

